#include <stdio.h>
#include <ctype.h>

#define REPLACE		' '			/* instead of whites */
#define LIMIT		20			/* cf. 'limit' below */
#define RANDOM		(lrand48()>>16)		/* randomize fct (long) */
#define MAXWIDTH	31			/* max. value for width - 1 */
#define MAXLINE		500			/* max. line length */
#define SYMBITEMS	500			/* # of simultaneously
						   allocated SYMB's */

#define isop6(c,c1) (c1 == '=' && (c == '-' || c == '*' || c == '+' || \
			c == '&'))
#define isopenclose(c) (isopen(c)||isclose(c))
#define isopen(c)	(c=='('||c=='['||c=='{')
#define isclose(c)	(c==')'||c==']'||c=='}')
#define isxnum(c)	(isalnum(c) || c=='_')

char *ARG0,
     *strchr(), *strcpy();

int width,				/* chars per variable name */
    length=0;				/* chars written per line */

typedef struct symb			/* symbol lists structure */
  {
   struct symb *next,
	       *trans;
   char symbname[MAXWIDTH+1];
  }
   SYMB;

SYMB *next_item();

FILE *fpo;				/* actual tempfile */

void srand(), Putchar();
long lrand48();

/* ----------------------------------------------------------------- */

main(argc,argv)
  char **argv;
  {
   char buf[512],
	outname[32],
	*p;

   int c,		/* actual character */
       c1='\n',		/* a formerly read character */
       c2,		/* test on '\n' in white sequence */
       flag1,		/* 1 if outside constant '...' */
       flag2,		/* 1 if outside string "..." */
       pflag=0,		/* 1 if preprocessor statement is active */
       incl_flag=0,	/* 1 if include-line */
       cnt,		/* counting max. 3 digits after '\' */
       argnr,		/* no.of argument */
       limit=0;		/* # of consecutive \nnn transformed */

   long seed;

   FILE *fp,		/* workfile pointer */
	*fpi;		/* actual infile */

   SYMB *csymbols=NULL,	/* list of transformed symbols */
	*osymbols=NULL,	/* ... of original symbols to be transformed */
	*asymbols=NULL,	/* list of all symbols */
	*runp;		/* work */

   ARG0 = argv[0];

   /* preparations */

   if(argc < 4 ||
      sscanf(argv[1], "%d", &width) != 1 || width < 0 || width > MAXWIDTH ||
      sscanf(argv[2], "%ld", &seed) != 1 || seed < 0l
     )
     {
      fprintf(stderr, "%s - illegal args: %s %s\n\07",
	      ARG0, argv[1], argv[2]);
      exit(1);
     }
   srand48(seed);
   sprintf(outname, "tmp%d.2", getppid());

   /* read input file 0: all symbols */

   sprintf(buf, "tmp%d.0", getppid()); fp = fopen(buf, "r"); /* no error */

   runp = asymbols = next_item(NULL);		/* make list "asymbols" */

   while(fgets(buf, 512, fp) != NULL)
     {
      *strchr(buf,'\n') = '\0';
      if(strlen(buf) == width)
	{
	 strcpy(runp->symbname, buf);
	 runp = next_item(runp);
	}
     }

   /* read second input file and make list of coded symbols */

   {
    register m, off;
    SYMB *codep,		/* transformed symbols */
	 *origp;		/* original symbols */

    sprintf(buf, "tmp%d.1", getppid()); fp = fopen(buf, "r"); /* no error */


    origp = osymbols = next_item(NULL);
    codep = csymbols = next_item(NULL);

    while(fgets(buf, 512, fp) != NULL)
      {
       *strchr(buf,'\n') = '\0';
       strcpy(origp->symbname, buf);

       for(;;)
	 {
	  /* make a random name */

	  p = codep->symbname;

	  for(m = 0; m < width; ++m)
	    {
	     if(m)
	       off = RANDOM % ((m&1) ? (26+26+10) : (26+26));
	     else off = RANDOM % 26;
	     if(off < 26)		*p++ = off + 'a';
	     else if(off < (26+26))	*p++ = off-26 + 'A';
	     else			*p++ = off-26-26 + '0';
	    }
	  *p = '\0'; p -= width;

	  /* check it on repetition */

	  for(runp = csymbols; runp->next != NULL; runp = runp->next)
	    if(!strcmp(runp->symbname, p)) break;	/* repeated */

	  if(runp->next == NULL)
	    for(runp = asymbols; runp != NULL; runp = runp->next)
	       if(!strcmp(runp->symbname, p)) break;	/* repeated */

	  if(runp == NULL)
	    {
	     /* write entry, add a line to file "translist.'pid'" */
	     origp->trans = codep;
	     printf("%s\t%s\n", origp->symbname, codep->symbname);
	     break;
	    }
	  else putc('.', stderr); 	/* repetition, try again */
	 }
       
       /* o.k., next name */

       origp = next_item(origp);
       codep = next_item(codep);
      }
   }

   /* --- transform the programs --- */

   for(argnr=3; argnr < argc; ++argnr)
     {
      fpi = fopen(argv[argnr], "r");		/* no error */
      fpo = fopen(outname, "w");

      fprintf(stderr, "transforming %s ...\n", argv[argnr]);

      for(flag1=flag2=1;;c1=c)
	{
   line_cont:
	 if((c=getc(fpi)) == EOF)
	   {
	    putc('\n', fpo);
	    fclose(fpo); fclose(fpi);
	    /* rename tempfile */
	    unlink(argv[argnr]); link(outname, argv[argnr]); unlink(outname);
	    break;				/* next argument */
	   }

	 /* test on "..." and '...' */

	 if(flag1 && c == '"')
	   {
	    if(flag2 ^= 1) limit = 0; Putchar(c); continue;
	   }
	 if(flag2 && c == '\'')
	   {
	    if(flag1 ^= 1) limit = 0; Putchar(c); continue;
	   }

	 /* test on line continuation */

	 if(flag1 && flag2 && c == '\\')
	  {
	   if((c = getc(fpi)) == '\n') goto line_cont;
	   Putchar('\\'); Putchar(c); continue;
	  }

	 /* test on preprocessor statement */

	 if(c1 == '\n')
	   {
	    if(pflag) {Putchar('\n'); incl_flag = 0;}
	    if(pflag = c=='#')
	      {
	       /* read keyword and test on #include */

	       Putchar('\n'); Putchar('#');
	       while(isspace(c=getc(fpi))) Putchar(c);
	       *(p=buf) = c;
	       do Putchar(c); while(isalpha(*++p=c=getc(fpi)));
	       *p = '\0';
	       incl_flag = !strcmp(buf,"include");
	      }
	   }

	 /* outside string and character constant */

	 if(flag1 && flag2)
	   {
	    /* cut off comments */

	    if(c=='/')
	      {
	       if((c=getc(fpi)) == '*')
		 {
		  for(;;)				/* yes, comment */
		    {
		     while(getc(fpi) != '*');
		     if((c=getc(fpi)) != '/') ungetc(c,fpi);
		     else break;
		    }
		  continue;
		 }
	       else
		 {
		  ungetc(c,fpi);			/* no, restore */
		  Putchar(c = '/');
		  continue;
		 }
	      }

	    /* transform symbols */

	    if(isxnum(c) && !incl_flag)
	      {
	       int allow = !isdigit(c);

	       /* ev. cut lines */
	       if(allow && length > MAXLINE - MAXWIDTH)
		  Putchar('\n');

	       c1 = c;

	       /* store the number or identifier in "buf" */

	       for(*(p=buf) = c; isxnum(c); *++p = c = getc(fpi)) c2 = c;
	       ungetc(c,fpi); c = c2;
	       *p = '\0';

	       /* ev. do substitution */

	       if(allow)
		 for(runp=osymbols;
		     runp->next != NULL && strcmp(buf,runp->symbname);
		     runp = runp->next);
	       length +=
		  fprintf(fpo, "%s",
		     !allow || runp->next == NULL ?
			(char *)buf : runp->trans->symbname);
	       c = p[-1];
	       continue;
	      }

	    /* write character, compress repeated whites */

	    if(!pflag && isspace(c))
	      {
	       c2 = c;
	       while(isspace(c=getc(fpi))) c2=c;
	       ungetc(c,fpi);
	       if(isxnum(c1) && isxnum(c) || isop6(c,c1) ||
		  c1 == '/' && c == '*')
		 Putchar(REPLACE);
	       c = c2;
	      }

	    /* add random comments */

	    else if(isopenclose(c))
	      {
	       int cold, cr;

	       if(isopen(c)) Putchar(c);
	       else if(c1 == '*') Putchar(REPLACE);

	       length += 2; fprintf(fpo, "/*"); cold = '*';
	       for(cnt = RANDOM % 6 + 2; cnt--;)
		 {
		  while((cr = RANDOM % 95 + ' ') == '\\');
		  if(cold=='*' && cr =='/' || cold=='/' && cr=='*') continue;
		  cold = cr;
		  Putchar(cr);
		 }
	       length += 2; fprintf(fpo, "*/");
	       
	       if(isclose(c)) Putchar(c);
	      }
	    else Putchar(c);
	    continue;
	   }

	 /* transform character constants and strings */

	 if(incl_flag) Putchar(c);

	 else if(c=='\\')
	   {
	    Putchar(c); cnt = 3; c = getc(fpi);

	    if(isdigit(c))
	      {
	       /* let unchanged */

	       while(isdigit(c) && cnt--) {Putchar(c); c = getc(fpi);}
	       ungetc(c,fpi);
	      }
	    else Putchar(c);
	    continue;
	   }
	 else			/* transform */
	   {
	    if(limit < LIMIT)
	      {length += fprintf(fpo, "\\%03o",c); ++limit;}
	    else Putchar(c);
	   }
	}
     }
   return 0;
  }

/* ----------------------------------------------------------------- */

/* care about memory for the next item, set the pointer to next item
   input: ap - pointer to newest item, NULL if first call
   return:     pointer to next item
*/

SYMB *next_item(ap)
  SYMB *ap;
  {
   char *malloc(), *csp;
   static symbcnt = 0;
   static SYMB *spold;

   if(!symbcnt--)
     {
      if((csp = malloc(SYMBITEMS*sizeof(SYMB))) == NULL)
	{
	 fprintf(stderr,
		 "can't malloc %d bytes - %s aborted\n\07",
		 SYMBITEMS*sizeof(SYMB), ARG0);
	 exit(1);
	}
      symbcnt = SYMBITEMS - 1;
     }
   else
     csp = (char *)spold + sizeof(SYMB);
   
   if(ap != NULL) ap->next = (SYMB *)csp;
   spold = (SYMB *)csp; spold->next = NULL; spold->trans = NULL;
   return (SYMB *) spold;
  }

/* ----------------------------------------------------------------- */

/* count characters written into 1 line */

void Putchar(c)
  {
   putc(c, fpo);
   if(c == '\n') length = 0; else ++length;
  }

/* ----------------------------------------------------------------- */
